<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8" />
    <!-- Bootstrap core CSS -->
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous" />
    <link href="../css/cwrc.css" rel="stylesheet" type="text/css" />
    <link rel="shortcut icon" href="../css/favicon.ico" type="image/x-icon" />
    <link rel="icon" href="../css/favicon.ico" type="image/x-icon" />
    <title>Introduction to SPARQL Queries</title>
</head>

<body>
    <nav class="navbar navbar-expand-lg navbar-dark fixed-top bg-dark">
        <a class="navbar-brand" href="/">
            <img src="http://sparql.cwrc.ca/images/cwrclogo-vert-white.png" height="30" class="align-top" alt="CWRC Logo" /> CWRC Linked Data</a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarCollapse" aria-controls="navbarCollapse" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarCollapse">
            <ul class="navbar-nav mr-auto">
                <li class="nav-item"><a class="nav-link" href="/">Home</a></li>
                <li class="nav-item"><a class="nav-link" href="/sparql">SPARQL Queries</a></li>
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        Preambles
                    </a>
                    <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                        <a class="dropdown-item" href="../cwrc-preamble-EN.html">CWRC Ontology</a>
                        <a class="dropdown-item" href="../genre-preamble-EN.html">Genre Ontology</a>
                        <a class="dropdown-item" href="../ii-preamble-EN.html">II Ontology</a>
                    </div>
                </li>
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        Specifications
                    </a>
                    <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                        <a class="dropdown-item" href="../cwrc.html">CWRC Ontology</a>
                        <a class="dropdown-item" href="../genre.html">Genre Ontology</a>
                        <a class="dropdown-item" href="../ii.html">II Ontology</a>
                    </div>
                </li>
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        Documentation
                    </a>
                    <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                        <a class="dropdown-item" href="our-dataset.html">Our Dataset</a>
                        <div class="dropdown-divider"></div>
                        <a class="dropdown-item" href="sparql-query-guide.html">SPARQL Query Guide</a>
                        <a class="dropdown-item" href="intro-to-sparql.html">Intro to SPARQL</a>
                        <a class="dropdown-item" href="query-modifiers.html">Query Modifiers</a>
                        <a class="dropdown-item" href="sample-queries.html">Sample Queries</a>
                        <a class="dropdown-item" href="load-into-huviz.html">Load into HuViz</a>
                    </div>
                </li>
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" id="NavbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        About
                    </a>
                    <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                        <a class="dropdown-item" href="cwrc.html">CWRC</a>
                        <a class="dropdown-item" href="linked-data.html">Linked Data</a>
                        <a class="dropdown-item" href="../our-team-EN.html">Our Team</a>
                        <a class="dropdown-item" href="https://github.com/cwrc/ontology">Github</a>
                    </div>
                </li>
            </ul>
            <span class="navbar-text">The Ontology of the Canadian Writing Research Collaboratory</span>
        </div>
    </nav>
    <div class="container-fluid">
        <div class="row">
            <nav class="col-xl-2 col-lg-3 col-md-12 d-none d-lg-block bg-light sidebar">
                <div class="sidebar-sticky">
                    <div class="sidebar-heading justify-content-between align-items-center px-3 mt-4 mb-1 text-muted">
                        <span>Table of Contents</span>
                        <a class="d-flex align-items-center text-muted" href="#"></a>
                        <div id="toc">
                            <!-- Table of Contents -->
                        </div>
                    </div>
                </div>
            </nav>
            <main role="main" class="col-xl-10 col-lg-9 col-md-12 ml-sm-auto pt-3 px-4" data-spy="scroll" data-target="#toc">
                <h1>An Introduction to SPARQL Queries</h1>
                <h2>What is SPARQL?</h2>
                <p>SPARQL (SPARQL Protocol and RDF Query Language, pronounced “sparkle”)
                    is a query language used to retrieve and manipulate linked data stored in an RDF format. In this format,
                    data are stored as triples. Triples are formed by a subject, predicate, and object. Together they form an assertion that the subject has a particular property or relationship, indicated by the predicate, to the object.</p>

                <!--To further consult: https://www.w3.org/TR/rdf-sparql-query/#:~:text=1.2.-,4%20Terminology,URIs%20%5BRFC3986%5D%20and%20URLs. -->

                <!--need a generic image of what a triple looks like (which may be covered by the one that isn't loading can't tell). Add a "Learn more" link to a page with introductory resources for those who want to read more.-->
                <!--image not loading in my browser- does the file need to be added to the directory or use an external URL?-->
                <!-- <img src="triple.png" alt="Triple" class="center_img"/> -->
                <strong>Example:</strong>
                <p>The best way to get started is to write a simple query:</p>
                <pre>
          <code>SELECT ?subject ?predicate ?object WHERE { 
  ?subject ?predicate ?object . 
}         </code>
        </pre>
                <p>This query will return all the triples in the dataset.</p>
                <h2>Components of a Query</h2>
                <p>Let's break down this query further.</p>
                <!-- insert heading here: VARIABLES:-->
                <strong class="red_bold">?:</strong>
                <p>Any word following a question mark is a variable.</p>
                <strong class="red_bold">SELECT:</strong>
                <p>The variables following SELECT will be displayed in a table. Other keywords such as CONSTRUCT, ASK, and DESCRIBE can be used to display other results.
                </p>
                <strong class="red_bold">WHERE:</strong>
                <p>The WHERE clause is mandatory and specifies where data will be extracted from. Other temporary variables
                    may be used here.</p>
                <p>Note: If a query may result in a large number of triples, modifiers such as LIMIT can be used to refine the search.
                    This topic will be explored in greater detail in the next section. <a href="http://sparql.cwrc.ca/sparql#query=SELECT+%3Fsubject+%3Fpredicate+%3Fobject+WHERE+%7B+%0A++%3Fsubject+%3Fpredicate+%3Fobject+.%0A%7D%0ALIMIT+10+&contentTypeConstruct=text%2Fturtle&contentTypeSelect=application%2Fsparql-results%2Bjson&endpoint=http%3A%2F%2Fsparql.cwrc.ca%2Fsparql&requestMethod=POST&tabTitle=Simple+Triple+Retrieval&headers=%7B%7D&outputFormat=table">The example</a> below will
                    display the first 10 results.
                </p>
                <pre>
          <code>Select ?subject ?predicate ?object WHERE { 
  ?subject ?predicate ?object .
}
LIMIT 10      </code>
        </pre>
                <h2>Prefixes and URIs</h2>
                <p>The data are stored in the form of triples with the subject, predicate, object format.
                    Each part of the triple is identified by a <a href="https://en.wikipedia.org/wiki/Uniform_Resource_Identifier">Uniform Resource Identifier (URI)</a>.
                    For example, the gender property <a href="http://sparql.cwrc.ca/ontologies/cwrc.html#woman">"woman"</a> in the CWRC Ontology is represented by the following URI: <a href="http://sparql.cwrc.ca/ontologies/cwrc.html#woman">&lt;http://sparql.cwrc.ca/ontologies/cwrc.html#woman&gt;</a> </p>
                <p> URIs in queries are often shortened using a prefix, or <a href="https://en.wikipedia.org/wiki/Namespace">namespace</a> which is defined at the beginning of the query. These stand in for most of the URI, leaving variable at the end which designate the terms from that ontology or vocabulary. </p>
                <p>Thus the same term above could be represented in a triple as: <strong>cwrc:woman</strong></p>
                <h2>A Simple Query</h2>
                <pre class="code">PREFIX cwrc: &lt;http://sparql.cwrc.ca/ontologies/cwrc#&gt;
PREFIX skos: &lt;http://www.w3.org/2004/02/skos/core#&gt;
SELECT ?name WHERE { 
    ?person cwrc:hasGender cwrc:woman . 
    ?person cwrc:hasOccupation cwrc:teacher .
    ?person skos:altLabel ?name
}
</pre>
                <p><a href="http://sparql.cwrc.ca/sparql#query=PREFIX+cwrc%3A+%3Chttp%3A%2F%2Fsparql.cwrc.ca%2Fontologies%2Fcwrc%23%3E%0APREFIX+skos%3A+%3Chttp%3A%2F%2Fwww.w3.org%2F2004%2F02%2Fskos%2Fcore%23%3E%0ASELECT+%3Fname+WHERE+%7B+%0A++++%3Fperson+cwrc%3AhasGender+cwrc%3Awoman+.+%0A++++%3Fperson+cwrc%3AhasOccupation+cwrc%3Ateacher+.%0A++%09%3Fperson+skos%3AaltLabel+%3Fname%0A%7D&contentTypeConstruct=text%2Fturtle&contentTypeSelect=application%2Fsparql-results%2Bjson&endpoint=http%3A%2F%2Fsparql.cwrc.ca%2Fsparql&requestMethod=POST&tabTitle=Teachers+who+were+women&headers=%7B%7D&outputFormat=table">This query</a> searches for all of the triples in the CWRC dataset that satisfy the following
                    requirements: the person is a woman and a teacher. </p>
                <p>In plain English, it could be translated as follows: </p>
                <p>
                    <em>There is a person who has the gender woman</em>
                </p>
                <p>
                    <em>That same person has an occupation of teacher</em>
                </p>
                <p>
                    <em>That person has a name represented by an alt label</em>
                </p>
                <h2>Notes on Style</h2>
                <p>Every triple in a query should end in a period.</p>
                <p>If a subject used in one line is repeated in the next line it can be omitted as long as there is a semicolon at the end to indicate use of the same subject.</p>
                
                <!-- Triple patterns with a common subject can be written so that the subject is only written once and is used for more than one triple pattern by employing the ";" notation.

 -->
                <p><a href="http://sparql.cwrc.ca/sparql#query=PREFIX+cwrc%3A+%3Chttp%3A%2F%2Fsparql.cwrc.ca%2Fontologies%2Fcwrc%23%3E%0APREFIX+skos%3A+%3Chttp%3A%2F%2Fwww.w3.org%2F2004%2F02%2Fskos%2Fcore%23%3E%0ASELECT+%3Fname+WHERE+%7B+%0A++++%3Fperson+cwrc%3AhasGender+cwrc%3Awoman%3B+%0A++++%09%09cwrc%3AhasOccupation+cwrc%3Ateacher%3B%0A++++++%09%09skos%3AaltLabel+%3Fname.%0A%7D&contentTypeConstruct=text%2Fturtle&contentTypeSelect=application%2Fsparql-results%2Bjson&endpoint=http%3A%2F%2Fsparql.cwrc.ca%2Fsparql&requestMethod=POST&tabTitle=Teachers+who+were+women+(%3B+notation)&headers=%7B%7D&outputFormat=table">Example:</a></p>
                <pre>
              <code>PREFIX cwrc: &lt;http://sparql.cwrc.ca/ontologies/cwrc#&gt;
PREFIX skos: &lt;http://www.w3.org/2004/02/skos/core#&gt;
SELECT ?name WHERE { 
    ?person cwrc:hasGender cwrc:woman; 
            cwrc:hasOccupation cwrc:teacher;
            skos:altLabel ?name.
}             </code>
            </pre>
            </main>
        </div>
    </div>
    <!-- Bootstrap core JavaScript
    ================================================== -->
    <!-- Placed at the end of the document so the pages load faster -->
    <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.11.0/umd/popper.min.js" integrity="sha384-b/U6ypiBEHpOf/4+1nzFpr53nxSS+GLCkfwBdFNTxtclqqenISfwAzpKaMNFNmj4" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh3U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.bundle.min.js" integrity="sha384-feJI7QwhOS+hwpX2zkaeJQjeiwlhOP+SdQDqhgvvo1DsjtiSQByFdThsxO669S2D" crossorigin="anonymous"></script>
    <script src="../js/toc.js"></script>
    <script src="../js/svg-pan-zoom.min.js"></script>
    <script>
    window.onload = function() {
        var options = {
            selector: 'h2, h3, h4, h5',
            scope: 'main'
        };

        var container = document.querySelector('#toc');
        var toc = initTOC(options);
        container.appendChild(toc);
    };
    </script>
</body>

</html>